<!--
================
Bootstrap - Flex
================
-->

<!-- 
References:
	Bootstrap Text Utility Classes
		https://getbootstrap.com/docs/4.6/utilities/text/
	Boostrap Color Utility Classes
		https://getbootstrap.com/docs/4.6/utilities/colors/
	Bootstrap Spacing Utility Classes
		https://getbootstrap.com/docs/4.6/utilities/spacing/
	CSS display Property
		https://www.w3schools.com/cssref/pr_class_display.asp
	CSS Flexbox
		https://www.w3schools.com/css/css3_flexbox.asp
	Bootstrap Flex Classes
		https://getbootstrap.com/docs/4.0/utilities/flex/
	CSS justify-content Property
		https://www.w3schools.com/cssref/css3_pr_justify-content.asp
	CSS align-items Property
		https://www.w3schools.com/cssref/css3_pr_align-items.asp
	CSS flex-direction Property
		https://www.w3schools.com/cssref/css3_pr_flex-direction.asp
	Bootstrap CSS Framework
		https://getbootstrap.com/
	Introduction to Bootstrap 4.6
		https://getbootstrap.com/docs/4.6/getting-started/introduction/
	Bootstrap local vs. CDN
		https://www.belugacdn.com/bootstrap-local-vs-cdn/
	Responsive Meta Tag
		https://css-tricks.com/snippets/html/responsive-meta-tag/
	Bootstrap Containers
		https://getbootstrap.com/docs/4.6/layout/overview/#containers
	Bootstrap Grid System classes
		https://getbootstrap.com/docs/4.0/layout/grid/
	Bootstrap Image Utility Classes
		https://getbootstrap.com/docs/4.6/content/images/
	Creating Git Projects:
		GitLab
			https://gitlab.com/projects/new#blank_project
		GitHub
			https://github.com/new
	Boodle
		https://boodle.zuitt.co/login/

Definition of terms:
	Batch Folder - The batch folder that will store all files of the students throughout the bootcamp. Normally located in the "Documents" folder of the device.
	Application - Root folder for the application

-->

<!-- 
==========
Discussion
========== 
-->

<!-- 
1. Create a "discussion" folder and an "index.html" file.
	Batch Folder > s13 > discussion > index.html
-->

		<!DOCTYPE html>
		<html>
		<head>
			<title>CSS and Bootstrap Flex</title>
		</head>
		<body>
		
		</body>
		</html>

<!--
2. Create an external CSS stylesheet named "index.css" file and create CSS rules that will mirror Bootstrap classes.
	Application > index.css
-->

		<style>

			/*CSS Reset*/
			* {
				margin: 0;
				padding: 0;
				box-sizing: border-box;
			}

			/*Bootstrap Font*/
			body {
				font-family: "Helvetica Neue", sans-serif;
			}

			.text-center {
				text-align: center;
			}

			.h-25 {
				height: 25%;
			}

			.p-3 {
				padding: 15px;
			}

			.bg-success {
				background-color: forestgreen;
			}

			.bg-warning {
				background-color: orange;
			}

			.bg-danger {
				background-color: darkred;
			}

		</style>

		<!--
		Important Note:
			- The style tag will not work in an external CSS file and is only used here for code readability and instruction. Omit this and add the CSS syntax instead.
			- The CSS rules created here mirror Bootstrap classes and are done for the appreciation of the students.
			- You may have the students copy the CSS rules for a faster discussion.
			- Refer to "references" section of this file to find the documentations for Bootstrap's Text, Color and Spacing Utility classes.
		-->

<!--
3. Add the link tag to connect the external CSS file with the HTML file.
	Application > index.html
-->

		<!DOCTYPE html>
		<html>
		<head>

			<!-- Custom CSS -->
			<link rel="stylesheet" href="index.css">

			<title>CSS and Bootstrap Flex</title>

		</head>
		<body>
		
		</body>
		</html>

<!--
4. Create a container, center the text elements and add another header tag and some text.
	Application > index.html
-->

		<!-- ... -->
		<body>

		    <div class="text-center">

		        <h1>Bootstrap Flex</h1>
		        <p>Use the d-flex class to create a flex container and transform direct children into flex items.</p>

		    </div>

			<script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
			<!-- ... -->

		</body>
		<!-- ... -->

<!--
5. Create several div tags and apply some style and color for visual reference.
	Application > index.html
-->

		<!-- ... -->
		<body>

		    <div class="text-center">

		        <!-- ... -->
		        <p>Use the d-flex class to create a flex container and transform direct children into flex items.</p>

		        <h2>Centering elements</h2>
		        <div style="height: 500px;" class="bg-secondary p-3">  
		            <div class="h-25 p-3 bg-success">Flex Item A</div>
		            <div class="h-25 p-3 bg-warning">Flex Item B</div>
		            <div class="h-25 p-3 bg-danger">Flex Item C</div>
		        </div>

		    </div>

			<script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
			<!-- ... -->

		</body>
		<!-- ... -->

<!--
6. Create a "d-flex" CSS rule that will mirror Bootstrap's Flex class.
	Application > index.css
-->

		<style>

			.bg-danger {
				/*...*/
			}

			/*CSS and Bootstrap Flexbox*/
			.d-flex {
				display: flex;
			}

		</style>

		<!--
		Important Note:
			- The "flex" value of the "display" property will change the element into a block-level flex container.
			- This will make all the child elements become "flexible" that allows them to occupy space enough for the content of an element and at the same time will have the elements appear beside each other.
			- Refer to "references" section of this file to find the documentations for CSS display Property, CSS Flexbox and Bootstrap Flex Classes.
		-->

<!--
7. Apply the "d-flex" class.
	Application > index.html
-->

		<!-- ... -->
		<body>

		    <div class="text-center">

		        <!-- ... -->

		        <h2>Centering elements</h2>
		        <div style="height: 500px;" class="bg-secondary p-3 d-flex">  
		            <!-- ... -->
		        </div>

		    </div>

			<script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
			<!-- ... -->

		</body>
		<!-- ... -->

		<!--
		Important Note:
			- The "d-flex" class will change all the child div elements into flex items.
			- The flex items will only occupy space enough for the element's content allowing is more flexibility to manipulate our elements.
		-->

<!--
8. Create a "justify-content-center" CSS rule that will mirror Bootstrap's Flex class.
	Application > index.css
-->

		<style>

			/*...*/

			.d-flex {
				/*...*/
			}

			.justify-content-center{
				justify-content: center;
			}

		</style>

		<!--
		Important Note:
			- The CSS "justify-content" property allows us to manipulate the positioning of elements horizontally.
			- Refer to "references" section of this file to find the documentations for CSS justify-content Property and Bootstrap Flex Classes.
		-->

<!--
9. Apply the "justify-content-center" class.
	Application > index.html
-->

		<!-- ... -->
		<body>

		    <div class="text-center">

		        <!-- ... -->

		        <h2>Centering elements</h2>
		        <div style="height: 500px;" class="bg-secondary p-3 d-flex justify-content-center">  
		            <!-- ... -->
		        </div>

		    </div>

			<script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
			<!-- ... -->

		</body>
		<!-- ... -->

		<!--
		Important Note:
			- The CSS "justify-content" property may only be applied if the element has a "flex" value for it's "display" property.
			- The "justify-content-center" class will horizontally center all child elements.
			- There may be instances that justify-content property may not work due to a lack of width on it's parent element.
			- Using the combination of the CSS "width" property and the justify-content property helps align elements horizontally.
		-->

<!--
10. Create an "align-items-center" CSS rule that will mirror Bootstrap's Flex class.
	Application > index.css
-->

		<style>

			/*...*/

			.justify-content-center{
				/*...*/
			}

			.align-items-center {
				align-items: center;
			}

		</style>

		<!--
		Important Note:
			- The CSS "align-items" property allows us to manipulate the positioning of elements vertically.
			- Refer to "references" section of this file to find the documentations for CSS align-items Property and Bootstrap Flex Classes.
		-->

<!--
11. Apply the "align-items-center" class.
	Application > index.html
-->

		<!-- ... -->
		<body>

		    <div class="text-center">

		        <!-- ... -->

		        <h2>Centering elements</h2>
		        <div style="height: 500px;" class="bg-secondary p-3 d-flex justify-content-center align-items-center">  
		            <!-- ... -->
		        </div>

		    </div>

			<script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
			<!-- ... -->

		</body>
		<!-- ... -->

		<!--
		Important Note:
			- The CSS "align-items" property may only be applied if the element has a "flex" value for it's "display" property.
			- The "align-items-center" class will vertically center all child elements.
			- There may be instances that align-items property may not work due to a lack of height on it's parent element.
			- Using the combination of the CSS "height" property and the align-items property helps align elements vertically.
		-->

<!--
12. Create a "flex-column" and "flex-column-reverse" CSS rule that will mirror Bootstrap's Flex class.
	Application > index.css
-->

		<style>

			/*...*/

			.align-items-center {
				/*...*/
			}

			.flex-column {
				flex-direction: column;
			}

			.flex-column-reverse {
				flex-direction: column-reverse;
			}

		</style>

		<!--
		Important Note:
			- The CSS "flex-direction" property allows us to manipulate the direction of how elements are positioned inside a flex container.
			- The "column-reverse" value will display the elements vertically.
			- Refer to "references" section of this file to find the documentations for CSS flex-direction Property and Bootstrap Flex Classes.
		-->

<!--
13. Apply the "flex-column" or "flex-column-reverse" class.
	Application > index.html
-->

		<!-- ... -->
		<body>

		    <div class="text-center">

		        <!-- ... -->

		        <h2>Centering elements</h2>
		        <div style="height: 500px;" class="bg-secondary p-3 d-flex justify-content-center align-items-center flex-column">  
		            <!-- ... -->
		        </div>

		    </div>

			<script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
			<!-- ... -->

		</body>
		<!-- ... -->

		<!--
		Important Note:
			- The CSS "flex-direction" property may only be applied if the element has a "flex" value for it's "display" property.
			- The "flex-column" class will display elements on top of each other.
			- A practical application of this might be to create a side navbar or centered items that should stack on top of each other.
			- Using the combination of the CSS "height" property and the align-items property helps align elements vertically.
		-->

<!--
14. Apply Bootstrap to the project by adding all the dependencies, comment out the external CSS and apply a container-fluid class to the outer div.
	Application > index.html
-->

		<!DOCTYPE html>
		<html>
		<head>

			<!-- Mobile Responsive Meta Tag -->
			<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

			<!-- Bootstrap Link -->
			<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css" integrity="sha384-B0vP5xmATw1+K9KRQjQERJvTumQW0nPEzvF6L/Z6nronJ3oUOFUFpCjEUQouq2+l" crossorigin="anonymous"/>

			<!-- Custom CSS -->
			<!-- <link rel="stylesheet" href="index.css"> -->

			<title>CSS and Bootstrap Flex</title>

		</head>
		<body>

			<div class="container-fluid text-center">
				<!-- ... -->
			</div>
		
			<!-- Bootstrap Script -->
			<script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
			<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.bundle.min.js" integrity="sha384-Piv4xVNRyMGpqkS2by6br4gNJ7DXjqk09RmUpJ8jgGtD7zP9yug3goQfGII0yAns" crossorigin="anonymous"></script>
			<!-- End of Bootstrap Script -->

		</body>
		</html>

		<!--
		Important Note:
			- By creating the CSS rules in the external CSS to mirror the class names used in Bootstrap, this will help reinforce the concept of how the Bootstrap Grid System works and the output using both the external CSS and Bootstrap will result to a similar output.
			- Upon completion of this material, Bootstrap 4.6 was the latest version.
			- To avoid any problems and errors encountered during the discussion, it is advised to implement the same version of Bootstrap.
			- An alternative way of implementing Bootstrap is to download it and store a copy in the local project.
			- The Responsive Meta Tag is responsible for making Bootstrap work properly. It disables the browser zoom view and allows elements to be rendered to scale to the size of the screen.
			- Refer to "references" section of this file to find the documentations for Bootstrap CSS Framework, Bootstrap local vs. CDN, Responsive Meta Tag and Bootstrap Containers.
			- Refer to "references" section of this file to find the documentation for Introduction to Bootstrap 4.6 on where to get the code snippets to apply Bootstrap into our project.
		-->

<!--
15. Create div elements and apply the "flex-row" and "flex-row-reverse" classes.
	Application > index.html
-->

		<!-- ... -->
		<body>

		    <div class="container-fluid text-center">

		        <!-- ... -->

		        <h2>Centering elements</h2>
		        <div style="height: 500px;" class="bg-secondary p-3 d-flex justify-content-center align-items-center flex-column">  
		            <!-- ... -->
		        </div>

		        <h2>Flex Row</h2>
		        <div class="bg-dark p-3 d-flex flex-row">  
		            <div class="p-3 bg-success">Flex Item A</div>
		            <div class="p-3 bg-warning">Flex Item B</div>
		            <div class="p-3 bg-danger">Flex Item C</div>
		        </div>

		        <h2>Flex Row Reverse</h2>
		        <div class="bg-dark p-3 d-flex flex-row-reverse">  
		            <div class="p-3 bg-success">Flex Item A</div>
		            <div class="p-3 bg-warning">Flex Item B</div>
		            <div class="p-3 bg-danger">Flex Item C</div>
		        </div>

		    </div>

			<!-- ... -->

		</body>
		<!-- ... -->

		<!--
		Important Note:
			- The "flex-row" and "flex-row-reverse" classes may only be applied if the element has a "flex" value for it's "display" property.
			- The CSS "flex-row" and "flex-row-reverse" classes changes how the elements are displayed horizontally.
		-->

<!-- 
========
Activity
======== 
-->

<!--
Instructions that can be provided to the students for reference:
=====================
Activity References
=====================
CSS display Property
	https://www.w3schools.com/cssref/pr_class_display.asp
CSS Flexbox
	https://www.w3schools.com/css/css3_flexbox.asp
Bootstrap Flex Classes
	https://getbootstrap.com/docs/4.0/utilities/flex/
CSS justify-content Property
	https://www.w3schools.com/cssref/css3_pr_justify-content.asp
CSS align-items Property
	https://www.w3schools.com/cssref/css3_pr_align-items.asp

=====================
Activity:
=====================
Member 1:
1. In the s13 folder, create an activity folder.
- Copy the template from boodle notes and paste it in the in the index.html file.
- Update your local sessions git repository and push to git with the commit message of Add template code s13.
2. Apply Bootstrap to the project by adding all the dependencies.
3. Apply Bootstrap classes to the Navbar Section with the following layout:
	- Using bootstrap flex, arrange the child elements of the navbar in a row.
	- Position the element with id brand to the left of its parent. You can add an automatic margin to the right.
	- Using bootstrap flex, arrange the child elements of the nav links div in a row.

Member 2:
4. Apply Bootstrap classes to the div with id “main” to make it as a fluid container and add a padding.
5. Apply Bootstrap classes to the div with id “other-projects” to make it as a row. 
	- Then, Add a bootstrap flex class to make sure the divs inside it are arranged with equal spaces around each child div.
	- Then, Add a bootstrap flex direction class to reverse the order of the divs but only from the medium screen.

Member 3:
6. Then, apply classes to the elements with id: bootstrap, html, nodejs :
	- When in a medium screen or larger screen, the 3 divs should appear side by side with 3 columns each.
	- When in a small screen, the contents should appear on top of each other.
	- Center the text inside the cards.
	- You can use bootstrap grid classes.

Member 4:
7. Apply Bootstrap Flex classes to the Core Tools Section with the following layout:
	- Make sure that the div with id core-tools is using flex and its 2 children are arranged in a column.
	- Make sure that the div id html is using flex and its children are centered horizontally using bootstrap flex classes.
	- Make sure that the div with id  css-js is using flex and its children are centered horizontally using bootstrap flex classes.

Member 5:
8. Apply Bootstrap Flex classes to the Other Tools Section with the following layout:
	- Make sure that the div with id other-tools is using flex and its 2 children are arranged in a column but only from the medium screen.
	- Make sure that the div with id tools-1 is using flex but only from the medium screen and its children are centered horizontally using bootstrap flex classes.
	- Make sure that the div with id tools-2 is using flex but only from the medium screen and its children are centered horizontally using bootstrap flex classes.

All Members:
9. Check out to your own git branch with git checkout -b <branchName>
10. Update your local sessions git repository and push to git with the commit message of Add activity code s13.
11. Add the sessions repo link in Boodle for s13.

-->

	<!DOCTYPE HTML>
	<html>
	    <head>

	        <!-- Mobile Responsive Meta Tag -->
	        <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

	        <!-- Bootstrap Link -->
	        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css" integrity="sha384-B0vP5xmATw1+K9KRQjQERJvTumQW0nPEzvF6L/Z6nronJ3oUOFUFpCjEUQouq2+l" crossorigin="anonymous"/>

	        <!-- Custom CSS -->
	        <!-- <link rel="stylesheet" href="index.css"> -->

	        <title>CSS and Bootstrap Flex</title>

	    </head>
	    <body>

	        <div class="container-fluid text-center">

	            <h1>Bootstrap Flex</h1>
	            <p>Use the d-flex class to create a flex container and transform direct children into flex items.</p>

	            <h2>Centering elements</h2>
	            <div style="height: 500px;" class="bg-secondary p-3 d-flex justify-content-center align-items-center flex-column">  
	                <div class="h-25 p-3 bg-success">Flex Item A</div>
	                <div class="h-25 p-3 bg-warning">Flex Item B</div>
	                <div class="h-25 p-3 bg-danger">Flex Item C</div>
	            </div>

	            <h2>Flex Row</h2>
	            <div class="bg-dark p-3 d-flex flex-row">  
	                <div class="p-3 bg-success">Flex Item A</div>
	                <div class="p-3 bg-warning">Flex Item B</div>
	                <div class="p-3 bg-danger">Flex Item C</div>
	            </div>

	            <h2>Flex Row Reverse</h2>
	            <div class="bg-dark p-3 d-flex flex-row-reverse">  
	                <div class="p-3 bg-success">Flex Item A</div>
	                <div class="p-3 bg-warning">Flex Item B</div>
	                <div class="p-3 bg-danger">Flex Item C</div>
	            </div>

	        </div>

	        <!-- Bootstrap Script -->
	        <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	        <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>
	        <!-- End of Bootstrap Script -->

	    </body>
	</html>

	<!--
	Important Note:
		- Provide the students with the "template-activity.html" file that will serve as the template for the first activity.
	-->

<!--
2. Create div elements and apply the "justify-content-around" class.
	Application > activity.html
-->

		<!-- ... -->
		<body>

		    <div class="container-fluid text-center">

		        <!-- ... -->

		        <h2>Flex Row Reverse</h2>
		        <div class="bg-dark p-3 d-flex flex-row-reverse">  
		            <!-- ... -->
		        </div>

		        <h2>Creating Space Between Elements</h2>
		        <div class="bg-dark p-3 d-md-flex justify-content-around">  
		            <div class="p-3 bg-success col-md-2">Card A</div>
		            <div class="p-3 bg-warning col-md-2">Card B</div>
		            <div class="p-3 bg-danger col-md-2">Card C</div>
		        </div>

		    </div>

			<!-- ... -->

		</body>
		<!-- ... -->

		<!--
		Important Note:
			- The "d-md-flex" class will apply a "flex" value to the "display" property on a "medium" sized screen and larger.
			- On smaller screens flex will not be applied to the parent element making it so elements will stack on top of each other.
			- The "col-md-2" will change the width of the child elements to occupy 2 out of 12 columns of it's parent container on medium screens and larger but will occupy the full width on mobile phones.
			- This approach is good for displaying elements side by side on tablets and larger screents but stacked on top of each other on small screens.
			- The "justify-content-around" class may only be applied if the element has a "flex" value for it's "display" property.
			- The "justify-content-around" class centers elements horizontally while creating space between elements and the borders of it's parent container.
		-->

<!--
3. Create div elements and apply a margin class on one of the elements.
	Application > activity.html
-->

		<!-- ... -->
		<body>

		    <div class="container-fluid text-center">

		        <!-- ... -->

		        <h2>Creating Space Between Elements</h2>
		        <div class="bg-dark p-3 d-md-flex justify-content-around">  
		            <!-- ... -->
		        </div>

		        <h2>Flexbox With Margin</h2>
		        <div class="bg-dark p-3 d-flex">  
		            <div class="p-3 bg-success mr-auto">Flex Item A</div>
		            <div class="p-3 bg-warning">Flex Item B</div>
		            <div class="p-3 bg-danger">Flex Item C</div>
		            <div class="p-3 bg-primary">Flex Item D</div>
		        </div>

		    </div>

			<!-- ... -->

		</body>
		<!-- ... -->

		<!--
		Important Note:
			- The "mr-auto" class will occupy the remaining width of it's parent container pushing all other elements inline.
		-->

<!--
4. Create div elements and apply a the Bootstrap Flex on nested elements.
	Application > activity.html
-->

		<!-- ... -->
		<body>

		    <div class="container-fluid text-center">

		        <!-- ... -->

		        <h2>Flexbox With Margin</h2>
		        <div class="bg-dark p-3 d-flex">  
		            <!-- ... -->
		        </div>

		        <h2>Nested Flex Elements</h2>
		        <div class="bg-dark p-3 d-block d-md-flex">  
		            <div class="p-3 bg-success mr-auto">Flex Item A</div>
		            <div class="w-50 d-block d-md-flex justify-content-between">
		                <div class="p-3 bg-warning">Flex Item B</div>
		                <div class="p-3 bg-danger">Flex Item C</div>
		                <div class="p-3 bg-primary">Flex Item D</div>
		            </div>
		        </div>

		    </div>

			<!-- ... -->

		</body>
		<!-- ... -->

		<!--
		Important Note:
			- The "d-" classes only applies to it's child elements and not to it's grandchild elements.
			- This is the reason why multiple "d-flex" classes are needed in order to align elements in nested div tags.
			- The combination of "d-block" and "d-md-flex" allows for elements to appear side by side on medium and larger screens and appear on top of each other on smaller screens.
			- The "d-block" class changes the "display" property of the "div" tag back to it's original "block" value.
			- The combination of the "w-50" and "justify-content-between" allows to create space between the flex items.
			- Unlike the "justify-content-around", the "justify-content-between" creates space between elements but removes the padding leftmost and rightmost padding of it's parent element.
		-->

<!-- 
5. Create an "activity2.html" file.
	Batch Folder > s13 > activity > activity2.html
-->

		<!DOCTYPE HTML>
		<html>
		    <head>

		        <title>Developer Portfolio: Other Projects and Tools</title>

		    </head>
		    <body>

		        <div>
		            <div>Ada Lovelace</div>
		            <div>
		                <div>About Me</div>
		                <div>Projects</div>
		                <div>Tools</div>
		            </div>
		        </div>

		        <div>

		            <h3>Other Projects</h3>

		            <!-- Other Projects Start -->
		            <div>

		                <!-- HTML Card Start -->
		                <div>
		                    <img src="https://3.bp.blogspot.com/-7x5c_f1yzsQ/XHv9FZKHrEI/AAAAAAAADrE/4iGl9Lm6K2odX4SdWbU_RN6gZesx4IaGACEwYBhgL/s1600/html.jpg">
		                    <h5>HTML</h5>
		                    <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod
		                    tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam,
		                    quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo
		                    consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse
		                    cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non
		                    proident, sunt in culpa qui officia deserunt mollit anim id est laborum.</p>
		                </div>
		                <!-- HTML Card End -->

		                <!-- Bootstrap Card Start -->
		                <div>
		                    <img src="https://ezywebbuilding.com/wp-content/uploads/2020/11/bootstrap-img.png">
		                    <h5>Bootstrap</h5>
		                    <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod
		                    tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam,
		                    quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo
		                    consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse
		                    cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non
		                    proident, sunt in culpa qui officia deserunt mollit anim id est laborum.</p>
		                </div>
		                <!-- Bootstrap Card End -->

		                <!-- Nose JS Server Card Start -->
		                <div>
		                    <img src="https://clever-solution.com/wp-content/uploads/2020/04/5625%D0%9C%D0%BE%D0%BD%D1%82%D0%B0%D0%B6%D0%BD%D0%B0%D1%8F-%D0%BE%D0%B1%D0%BB%D0%B0%D1%81%D1%82%D1%8C-1-1280x720.png">
		                    <h5>Node JS Server</h5>
		                    <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod
		                    tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam,
		                    quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo
		                    consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse
		                    cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non
		                    proident, sunt in culpa qui officia deserunt mollit anim id est laborum.</p>
		                </div>
		                <!-- Node JS Server Card End -->

		            </div>
		            <!-- Other Projects End -->

		            <!-- Tools Section Start -->
		            <div>

		                <!-- Core Tools Section Start -->
		                <h3>Core Tools</h3>

		                <div>
		                	<div>
		                    	<img width="150" src="images/logo-html5.png"/>
		                    </div>
		                    <div>
		                        <img width="150" src="images/logo-css3.png"/>
		                        <img width="150" src="images/logo-javascript.png"/>
		                    </div>
		                </div>
		                <!-- Core Tools Section End -->
		                
		                <!-- Other Tools Section Start -->
		                <h3>Other Tools</h3>

		                <div>
		                    <div>
		                        <img width="150" src="images/logo-mongodb.png"/>
		                        <img width="150" src="images/logo-nodejs.png"/>
		                        <img width="150" src="images/logo-expressjs.png"/>
		                        <img width="150" src="images/logo-react.png"/>
		                        <img width="150" src="images/logo-heroku.png"/>
		                    </div>
		                    <div class="mt-3">
		                        <img width="150" src="images/logo-git.png"/>
		                        <img width="150" src="images/logo-sublime-text-3.png"/>
		                        <img width="150" src="images/logo-postman.png"/>
		                        <img width="150" src="images/logo-gitlab-ci-cd.png"/>
		                    </div>
		                </div>
		                <!-- Other Tools Section End -->
		                
		            </div>
		            <!-- Tools Section End -->

		        </div>

		        <!-- Bootstrap Script -->
		        <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
		        <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.bundle.min.js" integrity="sha384-Piv4xVNRyMGpqkS2by6br4gNJ7DXjqk09RmUpJ8jgGtD7zP9yug3goQfGII0yAns" crossorigin="anonymous"></script>
		        
		    </body>
		</html>

		<!--
		Important Note:
			- Provide the students with the "template-activity2.html" file that will serve as the template for the second activity.
		-->

<!--
6. Apply Bootstrap to the project by adding all the dependencies.
	Application > index.html
-->

		<!DOCTYPE html>
		<html>
		<head>

			<!-- Mobile Responsive Meta Tag -->
			<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

			<!-- Bootstrap Link -->
			<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css" integrity="sha384-B0vP5xmATw1+K9KRQjQERJvTumQW0nPEzvF6L/Z6nronJ3oUOFUFpCjEUQouq2+l" crossorigin="anonymous"/>

			<title>Developer Portfolio: Other Projects and Tools</title>

		</head>
		<body>

			<!-- Bootstrap Script -->
			<script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
			<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.bundle.min.js" integrity="sha384-Piv4xVNRyMGpqkS2by6br4gNJ7DXjqk09RmUpJ8jgGtD7zP9yug3goQfGII0yAns" crossorigin="anonymous"></script>
			<!-- End of Bootstrap Script -->

		</body>
		</html>

<!--
7. Apply Bootstrap classes to the Navbar Section.
	Application > index.html
-->

		<!-- ... -->
		<body>
		
			<!-- Navbar Section Start -->
			<div class="bg-primary text-light d-flex">
			    <div class="p-3 mr-auto">Ada Lovelace</div>
			    <div class="d-flex">
			        <div class="p-3">About Me</div>
			        <div class="p-3">Projects</div>
			        <div class="p-3">Tools</div>
			    </div>
			</div>
			<!-- Navbar Section End -->

			<script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
			<!-- ... -->

		</body>
		</html>

<!--
8. Apply Bootstrap classes to the outer div tag of the Main Content Section to create a fluid container and add a padding.
	Application > index.html
-->

		<!-- ... -->
		<body>
	
	        <div class="bg-primary text-light d-flex">
	            <!-- ... -->
	        </div>

	        <!-- Main Content Section Start -->
	        <div class="container-fluid p-3">
	        	<!-- ... -->
			</div>
	        <!-- Main Content Section Start -->

		</body>
		<!-- ... -->

<!--
9. Apply Bootstrap classes to the Other Projects Section.
	Application > index.html
-->

		<!-- ... -->
		<body>
		
			<div class="bg-primary text-light d-flex">
			    <!-- ... -->
			</div>

			<!-- Main Content Section Start -->
			<div class="container-fluid p-3">

			    <h3 class="text-center">Other Projects</h3>

			    <!-- Other Projects Start -->
			    <div class="d-md-flex justify-content-around">

                    <!-- HTML Card Start -->
                    <div class="col-md-4 text-center">
                        <img class="img-fluid" src="https://3.bp.blogspot.com/-7x5c_f1yzsQ/XHv9FZKHrEI/AAAAAAAADrE/4iGl9Lm6K2odX4SdWbU_RN6gZesx4IaGACEwYBhgL/s1600/html.jpg">
                        <h5>HTML</h5>
                        <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod
                        tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam,
                        quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo
                        consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse
                        cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non
                        proident, sunt in culpa qui officia deserunt mollit anim id est laborum.</p>
                    </div>
                    <!-- HTML Card End -->

                    <!-- Bootstrap Card Start -->
                    <div class="col-md-4 text-center">
                        <img class="img-fluid" src="https://ezywebbuilding.com/wp-content/uploads/2020/11/bootstrap-img.png">
                        <h5>Bootstrap</h5>
                        <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod
                        tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam,
                        quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo
                        consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse
                        cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non
                        proident, sunt in culpa qui officia deserunt mollit anim id est laborum.</p>
                    </div>
                    <!-- Bootstrap Card End -->

                    <!-- Nose JS Server Card Start -->
                    <div class="col-md-4 text-center">
                        <img class="img-fluid" src="https://clever-solution.com/wp-content/uploads/2020/04/5625%D0%9C%D0%BE%D0%BD%D1%82%D0%B0%D0%B6%D0%BD%D0%B0%D1%8F-%D0%BE%D0%B1%D0%BB%D0%B0%D1%81%D1%82%D1%8C-1-1280x720.png">
                        <h5>Node JS Server</h5>
                        <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod
                        tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam,
                        quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo
                        consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse
                        cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non
                        proident, sunt in culpa qui officia deserunt mollit anim id est laborum.</p>
                    </div>
                    <!-- Node JS Server Card End -->

                </div>
			    <!-- Other Projects End -->

			</div>

			<script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
			<!-- ... -->

		</body>
		</html>

		<!--
		Important Note:
			- The "d-md-flex" class will apply a "flex" value to the "display" property on a "medium" sized screen and larger.
			- On smaller screens flex will not be applied to the parent element making it so elements will stack on top of each other.
			- The "col-md-4" will change the width of the child elements to occupy 4 out of 12 columns of it's parent container on medium screens and larger but will occupy the full width on mobile phones.
			- Refer to "references" section of this file to find the documentations for Bootstrap Grid System and Image Utility Classes.
		-->

<!--
10. Apply Bootstrap classes to the Tools Section.
	Application > index.html
-->

		<!-- ... -->
		<body>
		
			<div class="bg-primary text-light d-flex">
			    <!-- ... -->
			</div>

			<div class="container-fluid p-3">

			    <h3 class="text-center">Other Projects</h3>

			    <div class="d-md-flex justify-content-around">
					<!-- ... -->
			    </div>

			    <!-- Tools Section Start -->
			    <div class="mb-4">

			        <!-- Core Tools Section Start -->
			        <h3 class="text-center">Core Tools</h3>

			        <div class="d-flex flex-column">
			            <div class="d-flex justify-content-center">
			                <img width="150" src="images/logo-html5.png"/>
			            </div>
			            <div class="d-flex justify-content-center">
			                <img width="150" src="images/logo-css3.png"/>
			                <img width="150" src="images/logo-javascript.png"/>
			            </div>
			        </div>
			        <!-- Core Tools Section End -->
			        
			        <!-- Other Tools Section Start -->
			        <h3 class="text-center mt-3">Other Tools</h3>

			        <div class="d-flex flex-md-column">
	                    <div class="d-md-flex justify-content-center">
	                        <img width="150" src="images/logo-mongodb.png"/>
	                        <img width="150" src="images/logo-nodejs.png"/>
	                        <img width="150" src="images/logo-expressjs.png"/>
	                        <img width="150" src="images/logo-react.png"/>
	                        <img width="150" src="images/logo-heroku.png"/>
	                    </div>
	                    <div class="d-md-flex justify-content-center mt-3">
	                        <img width="150" src="images/logo-git.png"/>
	                        <img width="150" src="images/logo-sublime-text-3.png"/>
	                        <img width="150" src="images/logo-postman.png"/>
	                        <img width="150" src="images/logo-gitlab-ci-cd.png"/>
	                    </div>
	                </div>
			        <!-- Other Tools Section End -->
			        
			    </div>
			    <!-- Tools Section End -->

			</div>

			<!-- ... -->

		</body>
		</html>

		<!--
		Important Note:
			- The combination of the "d-flex and "flex-column" classes allows the images be displayed stacked on top of each other.
			- The combination of the "d-flex" and "justify-content-center" classes in the Core Tools Section allows to center the images horizontally in their respective containers.
			- The "d-" classes only applies to it's child elements and not to it's grandchild elements.
			- This is the reason why multiple "d-" classes are needed in order to align elements in nested div tags.
			- The combination of the "d-md-flex" and "justify-content-center" classes in the Other Tools Section allows to center the images horizontally in their respective containers on medium screens and larger.
			- On smaller screens flex will not be applied to the parent element making it so elements will stack on top of each other.
			- Refer to "references" section of this file to find the documentations for Bootstrap Grid System and Image Utility Classes.
		-->